<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_OfferSupplementType ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_OfferSupplementType extends AbstractStructArrayBase
{
    /**
     * The OfferSupplementType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_OfferSupplementType[]
     */
    public $OfferSupplementType;
    /**
     * Constructor method for ArrayOfJP_OfferSupplementType
     * @uses ArrayOfJP_OfferSupplementType::setOfferSupplementType()
     * @param \StructType\JP_OfferSupplementType[] $offerSupplementType
     */
    public function __construct(array $offerSupplementType = array())
    {
        $this
            ->setOfferSupplementType($offerSupplementType);
    }
    /**
     * Get OfferSupplementType value
     * @return \StructType\JP_OfferSupplementType[]|null
     */
    public function getOfferSupplementType()
    {
        return $this->OfferSupplementType;
    }
    /**
     * Set OfferSupplementType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_OfferSupplementType[] $offerSupplementType
     * @return \ArrayType\ArrayOfJP_OfferSupplementType
     */
    public function setOfferSupplementType(array $offerSupplementType = array())
    {
        foreach ($offerSupplementType as $arrayOfJP_OfferSupplementTypeOfferSupplementTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_OfferSupplementTypeOfferSupplementTypeItem instanceof \StructType\JP_OfferSupplementType) {
                throw new \InvalidArgumentException(sprintf('The OfferSupplementType property can only contain items of \StructType\JP_OfferSupplementType, "%s" given', is_object($arrayOfJP_OfferSupplementTypeOfferSupplementTypeItem) ? get_class($arrayOfJP_OfferSupplementTypeOfferSupplementTypeItem) : gettype($arrayOfJP_OfferSupplementTypeOfferSupplementTypeItem)), __LINE__);
            }
        }
        $this->OfferSupplementType = $offerSupplementType;
        return $this;
    }
    /**
     * Add item to OfferSupplementType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_OfferSupplementType $item
     * @return \ArrayType\ArrayOfJP_OfferSupplementType
     */
    public function addToOfferSupplementType(\StructType\JP_OfferSupplementType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_OfferSupplementType) {
            throw new \InvalidArgumentException(sprintf('The OfferSupplementType property can only contain items of \StructType\JP_OfferSupplementType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->OfferSupplementType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_OfferSupplementType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_OfferSupplementType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_OfferSupplementType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_OfferSupplementType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_OfferSupplementType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OfferSupplementType
     */
    public function getAttributeName()
    {
        return 'OfferSupplementType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_OfferSupplementType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
